---
title: BarcodeDetector
slug: Web/API/BarcodeDetector
tags:
  - Barcode Detection API
  - BarcodeDetector
  - Interface
  - barcode
  - barcode detector
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("Barcode Detector API")}}</div>

<p class="summary">The <strong><code>BarcodeDetector</code></strong> interface of the {{domxref('Barcode Detection API')}} allows detection of linear and two dimensional barcodes in images.</p>

<h2 id="Constructors">Constructors</h2>

<dl>
 <dt>{{domxref('BarcodeDetector.BarcodeDetector', 'BarcodeDetector.BarcodeDetector()')}}</dt>
 <dd>Creates and returns a <code>BarcodeDetector</code> object, with optional <code>barcodeDetectorOptions</code></dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref('BarcodeDetector.detect', 'detect()')}}</dt>
 <dd>Returns a {{domxref('Promise')}} which fulfills with an array of <code>detectedBarcode</code> objects with the following properties:
 <ul>
  <li><code>boundingBox</code>: A {{domxref('DOMRectReadOnly')}}, which returns the dimensions of a rectangle representing the extent of a detected barcode, aligned with the image.</li>
  <li><code>cornerPoints</code>: The x and y co-ordinates of the four corner points of the detected barcode relative to the image, starting with the top left and working clockwise. This may not be square due to perspective distortions within the image.</li>
  <li><code>format</code>: The detected barcode format. (For a full list of formats see the [landing page])</li>
  <li><code>rawValue</code>: A {{jsxref('String')}} decoded from the barcode data.</li>
 </ul>
 </dd>
 <dt>{{domxref('BarcodeDetector.getSupportedFormats', 'getSupportedFormats()')}}</dt>
 <dd>Returns a {{jsxref('Promise')}} which fulfills with an {{jsxref('Array')}} of supported <a href="/en-US/docs/Web/API/Barcode_Detection_API#Supported_barcode_formats">barcode format types</a>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_A_Detector">Creating A Detector</h3>

<p>This example creates a new barcode detector object, with specified supported formats and tests for browser compatibility.</p>

<pre class="brush: js notranslate">// create new detector
var barcodeDetector = new BarcodeDetector({formats: ['code_39', 'codabar', 'ean_13']});

// check compatibility
if (barcodeDetector) {
  console.log('Barcode Detector supported!');
} else {
  console.log('Barcode Detector is not supported by this browser.');
}</pre>

<h3 id="Getting_Supported_Formats">Getting Supported Formats</h3>

<p>The following example calls the <code>getSupportFormat()</code> static method and logs the results to the console.</p>

<pre class="brush: js notranslate">// check supported types
BarcodeDetector.getSupportedFormats()
  .then(formats =&gt; {
    supportedFormats.forEach(format =&gt; console.log(format));
  });</pre>

<h3 id="Detect_Barcodes">Detect Barcodes</h3>

<p>This example uses the <code>detect()</code> method to detect the barcodes within the given image. These are iterated over and the barcode data is logged to the console.</p>

<pre class="brush: js notranslate">  barcodeDetector.detect(imageEl)
    .then(barcodes =&gt; {
      barcodes.forEach(barcode =&gt; console.log(barcode.rawData));
    }
    .catch(err =&gt; {
      console.log(err);
    })
  </pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Shape Detection API','#barcodedetector','BarcodeDetector')}}</td>
   <td>{{Spec2('Shape Detection API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.BarcodeDetector")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="https://www.barcodefaq.com/">barcodefaq.com: A website with information about different barcodes and examples of the different types.</a></li>
 <li><a href="https://web.dev/shape-detection/#barcodedetector">Accelerated Shape Detection in Images</a></li>
</ul>
